import request from '~/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { Link, LinkParam } from './model';


/**
 * 分页查询链接
 */
export async function pageLink(params: LinkParam) {
  const res = await request.get<ApiResult<PageResult<Link>>>(
    '/oa/link/page',
    {
      params
    }
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询链接列表
 */
export async function listLink(params?: LinkParam) {
  const res = await request.get<ApiResult<Link[]>>(
    '/oa/link',
    {
      params
    }
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加链接
 */
export async function addLink(data: Link) {
  const res = await request.post<ApiResult<unknown>>(
    '/oa/link',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改链接
 */
export async function updateLink(data: Link) {
  const res = await request.put<ApiResult<unknown>>(
    '/oa/link',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除链接
 */
export async function removeLink(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    '/oa/link/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除链接
 */
export async function removeBatchLink(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    '/oa/link/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 检查IP是否存在
 */
export async function checkExistence(
  field: string,
  value: string,
  id?: number
) {
  const res = await request.get<ApiResult<unknown>>(
    '/oa/link/existence',
    {
      params: { field, value, id }
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}
